"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
exports.default = (cb) => {
    const [el, setEl] = react_1.useState(null);
    react_1.useEffect(() => {
        if (!el)
            return;
        let down = false;
        const handleEl = () => {
            down = true;
            setTimeout(() => down = false);
        };
        el.addEventListener("mousedown", handleEl);
        const handleDoc = () => !down && cb();
        document.addEventListener("mousedown", handleDoc);
        return () => {
            el.removeEventListener("mousedown", handleEl);
            document.removeEventListener("mousedown", handleDoc);
        };
    }, [el]);
    return setEl;
};
